#ifndef _PHYSICS_H
#define _PHYSICS_H

#define BALL_RADIUS                   8
#define WALL_WIDTH                   10
#define FRICTION_DECELERATION        20 /* 20 pixels per second^2 */

typedef struct ball {
    vector_t position;            /* position in pixels  */
    vector_t velocity;            /* velocity in pixels/sec */
} ball_t;

ball_t MoveAndDecelerate(ball_t ball, float t);
Boolean DetectCollision(ball_t moving, ball_t stationary);
vector_t Collide(ball_t moving, ball_t stationary);
vector_t Strike(vector_t start_spot, vector_t end_spot,
                vector_t transfer_velocity, vector_t ball_center);
ball_t BounceWall(ball_t ball);

#endif /* _PHYSICS_H */
